## synfigstudio 1.5.1

=== synfig-core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(synfig-core)

enable_testing()

# using latest stable standard, but not strictly
# the rest is done via target_compile_features instead
set(CMAKE_CXX_STANDARD 11)

add_subdirectory(src)
add_subdirectory(po)

add_dependencies(synfig_bin
    build_pofiles_synfig
)

=== synfig-studio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
include(SynfigIntltool)

project(synfigstudio)

# using latest stable standard, but not strictly
# the rest is done via target_compile_features instead
set(CMAKE_CXX_STANDARD 11)

add_subdirectory(src)

add_subdirectory(brushes)
add_subdirectory(images)
add_subdirectory(plugins)
add_subdirectory(po)
add_subdirectory(sounds)

file(MAKE_DIRECTORY "${SYNFIG_BUILD_ROOT}/share/appdata")
file(MAKE_DIRECTORY "${SYNFIG_BUILD_ROOT}/share/applications")

STUDIO_INTLTOOL_MERGE(
    TARGET_NAME appdata_xml
    INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/org.synfig.SynfigStudio.appdata.xml.in
    OUTPUT_FILE "org.synfig.SynfigStudio.appdata.xml"
    INSTALL_DESTINATION "share/appdata"
)

if(NOT WIN32) # desktop file needs to be build only for nix systems
STUDIO_INTLTOOL_MERGE(
    DESKTOP
    TARGET_NAME desktop_file
    INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/org.synfig.SynfigStudio.desktop.in
    OUTPUT_FILE "org.synfig.SynfigStudio.desktop"
    INSTALL_DESTINATION "share/applications"
)
endif()

if(TARGET desktop_file)
    add_custom_command(
        TARGET desktop_file POST_BUILD
        COMMAND sed -i -E \"s|^Icon=\(.*\)|Icon=/usr/share/icons/hicolor/scalable/apps/org.synfig.SynfigStudio.svg|g\"
            ${SYNFIG_BUILD_ROOT}/share/applications/org.synfig.SynfigStudio.desktop
    )
endif()

if(NOT MSVC)
add_dependencies(synfigstudio
    build_images
    build_pofiles_synfigstudio
)

if(TARGET plugins_xml)
    add_dependencies(synfigstudio plugins_xml)
endif()

if(TARGET appdata_xml)
    add_dependencies(synfigstudio appdata_xml)
endif()

if(TARGET desktop_file)
    add_dependencies(synfigstudio desktop_file)
endif()
endif()

=== ETL/test/CMakeLists.txt ===
# for test to find generated etl_profile.h
include_directories(${PROJECT_BINARY_DIR})

# for ETL headers
include_directories(${PROJECT_SOURCE_DIR})

add_executable(angle angle.cpp)
add_test(NAME test_angle COMMAND angle)

add_executable(fixed fixed.cpp)
add_test(NAME test_fixed COMMAND fixed)

add_executable(clock clock.cpp)
add_test(NAME test_clock COMMAND clock)

add_executable(handle handle.cpp)
add_test(NAME test_handle COMMAND handle)

add_executable(hermite hermite.cpp)
add_test(NAME test_hermite COMMAND hermite)

add_executable(stringf stringf.cpp)
add_test(NAME test_stringf COMMAND stringf)

add_executable(pen pen.cpp)
add_test(NAME test_pen COMMAND pen)

add_executable(surface surface.cpp)
add_test(NAME test_surface COMMAND surface)

add_executable(smart_ptr smart_ptr.cpp)
add_test(NAME test_smart_ptr COMMAND smart_ptr)

add_executable(benchmark benchmark.cpp)
add_test(NAME test_benchmark COMMAND benchmark)

set_target_properties(
		angle fixed clock handle hermite stringf pen surface smart_ptr benchmark
		PROPERTIES
		RUNTIME_OUTPUT_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/test
)

=== synfig-core/src/CMakeLists.txt ===
##
## Find packages
##

# TODO: check if we really need all of them
find_package(Boost REQUIRED system)

find_package(ZLIB REQUIRED)

## ETL doesn't install a package configuration so find package will fail
# find_package(ETL REQUIRED)


## TODO: investigate these more closely
set(CMAKE_THREAD_PREFER_PTHREAD ON)
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
if (CMAKE_USE_PTHREADS_INIT)
    set(HAVE_LIBPTHREAD ON)
endif()

# vcpkg should be checked before pkg-config, because some vcpkg
# packages have pkg-config support where others is not
if(VCPKG_TOOLCHAIN)
    message(STATUS "Building with vcpkg...")

	set(GLIB_LIB_SUFFIX 2.0)
	set(PANGO_LIB_SUFFIX 1.0)
	set(ATK_LIB_SUFFIX 1.0)
	set(GDK_PIXBUF_LIB_SUFFIX 2.0)
	if(CMAKE_BUILD_TYPE STREQUAL Debug)
	    set(CAIRO_LIB_SUFFIX d)
	    set(LIB_PNG_SUFFIX d)
	endif()

	# find dependencies

	# Libraries should be named in pkg-config style, so we can use the same names in target_link_libraries and target_include_libraries

	# glib
	find_path(GLIB_INCLUDE_DIR glib.h)
	find_library(GLIB_GLIB_LIBRARY glib-${GLIB_LIB_SUFFIX})
	find_library(GLIB_GIO_LIBRARY gio-${GLIB_LIB_SUFFIX})
	find_library(GLIB_GMODULE_LIBRARY gmodule-${GLIB_LIB_SUFFIX})
	find_library(GLIB_GOBJECT_LIBRARY gobject-${GLIB_LIB_SUFFIX})
	set(GLIB_LIBRARIES ${GLIB_GLIB_LIBRARY} ${GLIB_GIO_LIBRARY} ${GLIB_GMODULE_LIBRARY} ${GLIB_GOBJECT_LIBRARY} CACHE INTERNAL "")

	# pango
	find_path(PANGO_INCLUDE_DIR pango/pango.h)
	find_library(PANGO_LIBRARY pango-${PANGO_LIB_SUFFIX})
	find_library(PANGO_CAIRO_LIBRARY pangocairo-${PANGO_LIB_SUFFIX})
	find_library(PANGO_WIN32_LIBRARY pangowin32-${PANGO_LIB_SUFFIX})
	set(PANGO_LIBRARIES ${PANGO_LIBRARY} ${PANGO_CAIRO_LIBRARY} ${PANGO_WIN32_LIBRARY})

	# atk
	find_path(ATK_INCLUDE_DIR atk/atk.h)
	find_library(ATK_LIBRARY atk-${ATK_LIB_SUFFIX})

	# atkmm (required for gtkmm)
	find_library(ATKMM_LIBRARY atkmm)

	# cairo
	find_path(CAIRO_INCLUDE_DIR cairo.h)
	find_library(CAIRO_LIBRARY cairo${CAIRO_LIB_SUFFIX})
	find_library(CAIRO_GOBJECT_LIBRARY cairo-gobject${CAIRO_LIB_SUFFIX})
	find_library(CAIROMM_LIBRARY cairomm-1.0)
	set(CAIRO_LIBRARIES ${CAIRO_LIBRARY} ${CAIRO_GOBJECT_LIBRARY})

	# fftw3
	find_path(FFTW_INCLUDE_DIR fftw3.h)
	find_library(FFTW3_LIBRARY fftw3)
	find_library(FFTW3f_LIBRARY fftw3f)
	find_library(FFTW3l_LIBRARY fftw3l)
	set(FFTW_LIBRARIES ${FFTW3_LIBRARY} ${FFTW3f_LIBRARY} ${FFTW3l_LIBRARY})

	# gdk
	#find_path(GDK_INCLUDE_DIR gdk/gdk.h)
	find_library(GDK_LIBRARY gdk-3.0)
	find_library(GDKMM_LIBRARY gdkmm)
	find_library(GIOMM_LIBRARY giomm)
	find_library(GLIBMM_LIBRARY glibmm-2.0)
	find_library(GTK_LIBRARY gtk-3.0)
	find_library(GTKMM_LIBRARY gtkmm)
	find_library(PANGOFT2_LIBRARY pangoft2-${PANGO_LIB_SUFFIX})
	find_library(PANGOMM_LIBRARY pangomm)
	find_library(SIGC_LIBRARY sigc-2.0)
	#find_library(SIGCPP_LIBRARY sigc++-2.0)

    find_library(LIBXML_LIBRARY libxml2)
    find_library(XMLPP_LIBRARY xml++)
	find_library(ZLIB_LIBRARY zlib${CAIRO_LIB_SUFFIX})
	find_library(LTDL_LIBRARY ltdl)

    #libpng, libjpeg, freetype
    find_library(LIBPNG_LIBRARY libpng16${LIB_PNG_SUFFIX})
    find_library(LIBJPEG_LIBRARIES jpeg${LIB_PNG_SUFFIX})
    find_library(FREETYPE_LIBRARY freetype${LIB_PNG_SUFFIX})

    #set(SIGCPP_LIBRARIES ${SIGC_LIBRARY} ${SIGCPP_LIBRARY})
    set(SIGCPP_LIBRARIES ${SIGC_LIBRARY})
    set(GIOMM_LIBRARIES ${GLIB_GIO_LIBRARY} ${GIOMM_LIBRARY})
    set(GLIBMM_LIBRARIES ${GLIBMM_LIBRARY} ${GLIB_GLIB_LIBRARY})
    set(LIBPNG_LIBRARIES ${LIBPNG_LIBRARY})
    set(FT_LIBRARIES ${FREETYPE_LIBRARY})
    set(XMLPP_LIBRARIES ${LIBXML_LIBRARY} ${XMLPP_LIBRARY})
    set(ZLIB_LIBRARIES ${ZLIB_LIBRARY})

	# pkg-config --libs gtkmm-3.0
    #-LC:/msys64/mingw64/lib -lgtkmm-3.0 -latkmm-1.6 -lgdkmm-3.0 -lgiomm-2.4
    # -lpangomm-1.4 -lglibmm-2.4 -lgtk-3 -lgdk-3 -lz -lgdi32 -limm32 -lshell32
    # -lpangowin32-1.0 -lpangocairo-1.0 -lpango-1.0 -lharfbuzz -latk-1.0
    #-lcairo-gobject -lgio-2.0 -lcairomm-1.0 -lcairo -lsigc-2.0 -lgdk_pixbuf-2.0 -lgobject-2.0 -lglib-2.0 -lintl

    set(GTKMM_LIBRARIES ${ATK_LIBRARY} ${ATKMM_LIBRARY} ${GDKMM_LIBRARY} ${GIOMM_LIBRARY} ${PANGOMM_LIBRARY} ${GLIBMM_LIBRARY} ${GTKMM_LIBRARY})

    message(STATUS "+++++++++++++++++++++++ ${GTKMM_LIBRARIES} +++++++++++++++++++++++++++++++")


	# gdk-pixbuf
	find_path(GDK_PIXBUF_INCLUDE_DIR gdk-pixbuf/gdk-pixbuf.h)
	find_library(GDK_PIXBUF_LIBRARY gdk_pixbuf-${GDK_PIXBUF_LIB_SUFFIX})

	# epoxy
	find_path(EPOXY_INCLUDE_DIR epoxy/common.h)
	find_library(EPOXY_LIBRARY epoxy)

	# gettext
	find_path(LIBINTL_INCLUDE_DIR libintl.h)
	find_library(LIBINTL_LIBRARY NAMES intl libintl)

	message(STATUS "")
	message(STATUS "===================================================================================")
	foreach(REQUIRED_LIB
			ATK_LIBRARY
			ATKMM_LIBRARY
			CAIRO_GOBJECT_LIBRARY
			CAIRO_LIBRARY
			CAIROMM_LIBRARY
			GLIB_GLIB_LIBRARY
			FFTW3_LIBRARY
			FFTW3f_LIBRARY
			FFTW3l_LIBRARY
			GDK_LIBRARY
			GDKMM_LIBRARY
			GIOMM_LIBRARY
			GLIBMM_LIBRARY
			GTK_LIBRARY
			GTKMM_LIBRARY
			PANGOFT2_LIBRARY
			PANGOMM_LIBRARY
			SIGC_LIBRARY
			XMLPP_LIBRARY
			ZLIB_LIBRARY
	)
		message(STATUS "Checking for module '${REQUIRED_LIB}'")
		if(${REQUIRED_LIB})
			message(STATUS "  Found ${${REQUIRED_LIB}}")
		else()
			message(STATUS "  NOT FOUND!")
		endif()
	endforeach()
else()
	message(STATUS "Building with pkg-config...")
	include(FindPkgConfig)
    if(PKG_CONFIG_FOUND)
		pkg_check_modules(SIGCPP REQUIRED sigc++-2.0)
		pkg_check_modules(GLIB REQUIRED glib-2.0)
		pkg_check_modules(GLIBMM REQUIRED glibmm-2.4)
		pkg_check_modules(GIOMM REQUIRED giomm-2.4)
		pkg_check_modules(LIBXML REQUIRED libxml++-2.6)
		pkg_check_modules(MLT mlt++)
		pkg_check_modules(FFTW REQUIRED fftw3)
		pkg_check_modules(LIBPNG REQUIRED libpng) # for mod_png
		#TODO(ice0): find solution for libmng
		pkg_check_modules(LIBMNG libmng) # for mod_mng (set as optional as it is not correctly installed in Debian)
		pkg_check_modules(LIBJPEG REQUIRED libjpeg) # for mod_mng
		pkg_check_modules(OPENEXR OpenEXR) # for mod_openexr
		pkg_check_modules(MAGICKCORE REQUIRED MagickCore) # for Magick++

		## TODO: move to module where it is actually required
		pkg_check_modules(FT REQUIRED freetype2) # for lyr_freetype
		pkg_check_modules(FONT_CONFIG fontconfig) # for FontConfig
		pkg_check_modules(FRIBIDI REQUIRED fribidi)
		pkg_check_modules(HARFBUZZ REQUIRED harfbuzz)
	endif()
endif()

if (NOT MLT_FOUND)
	add_definitions(-DWITHOUT_MLT) # disable MLT if not found
endif()

foreach(pkg_config_lib 
  SIGCPP 
  GLIBMM 
  GIOMM 
  LIBXML
  MLT 
  FFTW 
  LIBPNG
  LIBMNG
  LIBJPEG
  OPENEXR
  MAGICKCORE)
    include_directories(${${pkg_config_lib}_INCLUDE_DIRS})
    link_directories(${${pkg_config_lib}_LIBRARY_DIRS})
endforeach()

## TODO: should we keep it here?
find_package(ImageMagick COMPONENTS Magick++)

##
## Configure
##

# Check headers
include(CheckIncludeFile)
CHECK_INCLUDE_FILE(sys/wait.h  HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILE(signal.h    HAVE_SIGNAL_H)
CHECK_INCLUDE_FILE(termios.h   HAVE_TERMIOS_H)
CHECK_INCLUDE_FILE(process.h   HAVE_PROCESS_H)
CHECK_INCLUDE_FILE(io.h        HAVE_IO_H)
CHECK_INCLUDE_FILE(sys/fcntl.h HAVE_FCNTL_H)

# Check functions
include (CheckFunctionExists)
CHECK_FUNCTION_EXISTS(fork HAVE_FORK)
CHECK_FUNCTION_EXISTS(pipe HAVE_PIPE)
CHECK_FUNCTION_EXISTS(waitpid HAVE_WAITPID)

add_definitions(-DHAVE_CONFIG_H)
configure_file(config.h.cmake.in config.h)
configure_file(autorevision.h.cmake.in autorevision.h)

##
## Include
##

## for config
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

##
## CMake helpers
##

include(cmake/install_header.cmake)

##
## Sub-dirs
##

add_subdirectory(synfig)
add_subdirectory(tool)
add_subdirectory(modules)

##
## Build targets
##

=== synfig-studio/brushes/CMakeLists.txt ===
add_subdirectory(CD_concept)

=== synfig-studio/images/CMakeLists.txt ===
set(IMG_SOURCE_animate_mode_off_icon animate_mode_icons 0)
set(IMG_SOURCE_animate_mode_on_icon animate_mode_icons 1)

set(IMG_SOURCE_interpolation_type_tcb_icon interpolation_type_icons 1)
set(IMG_SOURCE_interpolation_type_linear_icon interpolation_type_icons 2)
set(IMG_SOURCE_interpolation_type_ease_icon interpolation_type_icons 3)
set(IMG_SOURCE_interpolation_type_const_icon interpolation_type_icons 4)
set(IMG_SOURCE_interpolation_type_clamped_icon interpolation_type_icons 5)
# set(IMG_SOURCE_interpolation_type_unknown_icon interpolation_type_icons 6)
set(IMG_SOURCE_valuenode_forbidanimation_icon interpolation_type_icons 7)

set(IMG_SOURCE_action_doc_new_icon action_doc_icons 1)
set(IMG_SOURCE_action_doc_open_icon action_doc_icons 2)
set(IMG_SOURCE_action_doc_save_icon action_doc_icons 3)
set(IMG_SOURCE_action_doc_saveas_icon action_doc_icons 4)
set(IMG_SOURCE_action_doc_saveall_icon action_doc_icons 5)
set(IMG_SOURCE_action_doc_undo_icon action_doc_icons 6)
set(IMG_SOURCE_action_doc_redo_icon action_doc_icons 7)

set(IMG_SOURCE_canvas_icon canvas_and_importimage_icons 2)
set(IMG_SOURCE_layer_other_importimage_icon canvas_and_importimage_icons 1)

set(IMG_SOURCE_animate_seek_next_keyframe_icon framedial_icons 0)
set(IMG_SOURCE_animate_seek_prev_keyframe_icon framedial_icons 1)
set(IMG_SOURCE_animate_seek_next_frame_icon framedial_icons 2)
set(IMG_SOURCE_animate_seek_prev_frame_icon framedial_icons 3)
set(IMG_SOURCE_animate_seek_begin_icon framedial_icons 4)
set(IMG_SOURCE_animate_seek_end_icon framedial_icons 5)
set(IMG_SOURCE_animate_play_icon framedial_icons 6)
set(IMG_SOURCE_animate_stop_icon framedial_icons 7)
set(IMG_SOURCE_animate_pause_icon framedial_icons 8)
set(IMG_SOURCE_animate_loop_icon framedial_icons 9)
set(IMG_SOURCE_animate_bounds_icon framedial_icons 10)
set(IMG_SOURCE_animate_bound_lower_icon framedial_icons 11)
set(IMG_SOURCE_animate_bound_upper_icon framedial_icons 12)

set(IMG_SOURCE_keyframe_lock_past_on_icon keyframe_lock_icons 0)
set(IMG_SOURCE_keyframe_lock_past_off_icon keyframe_lock_icons 1)
set(IMG_SOURCE_keyframe_lock_future_on_icon keyframe_lock_icons 2)
set(IMG_SOURCE_keyframe_lock_future_off_icon keyframe_lock_icons 3)

set(IMG_SOURCE_utils_chain_link_on_icon utils_chain_link_icons 0)
set(IMG_SOURCE_utils_chain_link_off_icon utils_chain_link_icons 1)

set(ICONS
	animate_mode_off_icon
	animate_mode_on_icon

	interpolation_type_tcb_icon
	interpolation_type_linear_icon
	interpolation_type_ease_icon
	interpolation_type_const_icon
	interpolation_type_clamped_icon
	valuenode_forbidanimation_icon

	action_doc_new_icon
	action_doc_open_icon
	action_doc_save_icon
	action_doc_saveas_icon
	action_doc_saveall_icon
	action_doc_undo_icon
	action_doc_redo_icon

	canvas_icon

	animate_seek_next_keyframe_icon
	animate_seek_prev_keyframe_icon
	animate_seek_next_frame_icon
	animate_seek_prev_frame_icon
	animate_seek_end_icon
	animate_seek_begin_icon
	animate_play_icon
	animate_stop_icon
	animate_pause_icon
	animate_loop_icon
	animate_bounds_icon
	animate_bound_lower_icon
	animate_bound_upper_icon

	keyframe_lock_past_on_icon
	keyframe_lock_past_off_icon
	keyframe_lock_future_on_icon
	keyframe_lock_future_off_icon

	utils_chain_link_on_icon
	utils_chain_link_off_icon

	action_add_to_set_icon
	action_export_icon
	action_flat_interpolation_icon
	action_interpolate_interpolation_icon
	action_peak_interpolation_icon
	action_remove_from_set_icon
	action_rounded_interpolation_icon
	action_set_layer_description_icon
	action_squared_interpolation_icon
	action_unexport_icon
	clear_redo_icon
	clear_undo_icon
	decr_resolution_icon
	duck_angle_icon
	duck_position_icon
	duck_radius_icon
	duck_tangent_icon
	duck_vertex_icon
	duck_width_icon
	duplicate_icon
	graphs_icon
	group_icon
	history_icon
	incr_resolution_icon
	info_icon
	jack_icon
	keyframe_icon
	layer_blur_blur_icon
	layer_blur_motion_icon
	layer_blur_radial_icon
	layer_distortion_curvewarp_icon
	layer_distortion_insideout_icon
	layer_distortion_noise_icon
	layer_distortion_spherize_icon
	layer_distortion_stretch_icon
	layer_distortion_twirl_icon
	layer_distortion_warp_icon
	layer_example_metaballs_icon
	layer_example_simplecircle_icon
	layer_filter_clamp_icon
	layer_filter_colorcorrect_icon
	layer_filter_halftone2_icon
	layer_filter_halftone3_icon
	layer_filter_lumakey_icon
	layer_fractal_julia_icon
	layer_fractal_mandelbrot_icon
	layer_geometry_advanced_outline_icon
	layer_geometry_checkerboard_icon
	layer_geometry_circle_icon
	layer_geometry_outline_icon
	layer_geometry_polygon_icon
	layer_geometry_rectangle_icon
	layer_geometry_region_icon
	layer_geometry_solidcolor_icon
	layer_geometry_star_icon
	layer_gradient_conical_icon
	layer_gradient_curve_icon
	layer_gradient_linear_icon
	layer_gradient_noise_icon
	layer_gradient_radial_icon
	layer_gradient_spiral_icon
	layer_icon
	layer_other_duplicate_icon
	layer_other_group_icon
	layer_other_importimage_icon
	layer_other_plant_icon
	layer_other_skeleton_icon
	layer_other_sound_icon
	layer_other_stroboscope_icon
	layer_other_supersample_icon
	layer_other_switch_icon
	layer_other_text_icon
	layer_other_timeloop_icon
	layer_other_xorpattern_icon
	layer_stylize_bevel_icon
	layer_stylize_shade_icon
	layer_transform_rotate_icon
	layer_transform_scale_icon
	layer_transform_translate_icon
	layer_transform_zoom_icon
	library_icon
	meta_data_icon
	navigator_icon
	onion_skin_icon
	palette_icon
	parameters_icon
	preview_options_icon
	background_rendering_icon
	rename_icon
	render_options_icon
	reset_colors_icon
	resize_disabled_icon
	resize_up_left_icon
	resize_up_icon
	resize_up_right_icon
	resize_left_icon
	resize_right_icon
	resize_down_left_icon
	resize_down_icon
	resize_down_right_icon
	resize_transparent_icon
	select_all_child_layers_icon
	set_fill_color
	set_icon
	set_outline_color
	show_grid_icon
	show_guideline_icon
	sif_icon
	snap_grid_icon
	snap_guideline_icon
	swap_colors_icon
	time_track_icon
	tool_brush_icon
	tool_circle_icon
	tool_cutout_icon
	tool_draw_icon
	tool_eyedrop_icon
	tool_fill_icon
	tool_gradient_icon
	tool_mirror_icon
	tool_normal_icon
	tool_polyline_icon
	tool_rectangle_icon
	tool_rotate_icon
	tool_scale_icon
	tool_sketch_icon
	tool_smooth_move_icon
	tool_spline_icon
	tool_skeleton_icon
	tool_star_icon
	tool_text_icon
	tool_width_icon
	tool_zoom_icon
	type_angle_icon
	type_bool_icon
	type_canvas_icon
	type_color_icon
	type_gradient_icon
	type_integer_icon
	type_list_icon
	type_real_icon
	type_segment_icon
	type_splinepoint_icon
	type_string_icon
	type_time_icon
	type_vector_icon
	utils_timetrack_align_icon
	valuenode_icon
)

set(IMAGES
	about_icon
	logo
	synfig_icon
	${ICONS}
)

set(PIXMAPS_DIR ${SYNFIG_BUILD_ROOT}/share/synfig/icons/classic)

file(MAKE_DIRECTORY ${PIXMAPS_DIR})

## TODO: configure icon size
#
# Implement icon sizes after Synfig Studio uses Gtk::IconTheme
# For now just render to the default document size like Autotools does
#
# Note to protential future contributors:
# Not all icons are of aspect 1:1, eg- toggle button chain link
# so the below code is faulty and needs to be corrected
#
#foreach (ICON IN ITEMS ${ICONS})
#	set(IMG_SIZE_${ICON} 32 32)
#endforeach()

foreach (IMAGE IN ITEMS ${IMAGES})
	if (IMG_SOURCE_${IMAGE})
		list(GET IMG_SOURCE_${IMAGE} 0 SRC)
		list(GET IMG_SOURCE_${IMAGE} 1 TIME)
	else()
		set(SRC ${IMAGE})
		set(TIME 0)
	endif()
	# Wait for Gtk::IconTheme
#	if (IMG_SIZE_${IMAGE})
#		list(GET IMG_SIZE_${IMAGE} 0 W)
#		list(GET IMG_SIZE_${IMAGE} 1 H)
#	else()
#		set(W 0)
#		set(H 0)
#	endif()
	add_custom_command(
		OUTPUT ${PIXMAPS_DIR}/${IMAGE}.png
		# Wait for Gtk::IconTheme
#		COMMAND synfig_bin ${SRC}.sif -o ${PIXMAPS_DIR}/${IMAGE}.png --time ${TIME}f -w ${W} -h ${H} --quiet
		COMMAND synfig_bin ${SRC}.sif -o ${PIXMAPS_DIR}/${IMAGE}.png --time ${TIME}f --quiet
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${SRC}.sif synfig_bin
	)

	list(APPEND PIXMAPS ${PIXMAPS_DIR}/${IMAGE}.png)
	install(
		FILES ${PIXMAPS_DIR}/${IMAGE}.png
		DESTINATION share/synfig/icons/classic
	)
endforeach()

# Scalable Icon
file(
	COPY ${CMAKE_CURRENT_SOURCE_DIR}/org.synfig.SynfigStudio.svg
	DESTINATION ${SYNFIG_BUILD_ROOT}/share/icons/hicolor/scalable/apps
)

install(
	FILES ${CMAKE_CURRENT_SOURCE_DIR}/org.synfig.SynfigStudio.svg
	DESTINATION share/icons/hicolor/scalable/apps
)

# Synfig Splash Screen
if(${CMAKE_BUILD_TYPE} MATCHES Debug)
	set(SYNFIG_SPLASH_SCREEN ${CMAKE_CURRENT_BINARY_DIR}/splash_screen_development.sif)
	configure_file(
		${CMAKE_CURRENT_SOURCE_DIR}/splash_screen_development.sif.in
		${SYNFIG_SPLASH_SCREEN}
		@ONLY
	)

	set(LOGO_ICON ${CMAKE_CURRENT_SOURCE_DIR}/logo.sif)
	file(COPY ${LOGO_ICON} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
else()
	set(SYNFIG_SPLASH_SCREEN ${CMAKE_CURRENT_SOURCE_DIR}/splash_screen.sif)
endif()

set(SPLASH_SCREEN_DIR ${SYNFIG_BUILD_ROOT}/share/synfig/images)
file(MAKE_DIRECTORY ${SPLASH_SCREEN_DIR})
add_custom_command(
	OUTPUT ${SPLASH_SCREEN_DIR}/splash_screen.png
	COMMAND synfig_bin ${SYNFIG_SPLASH_SCREEN} -o ${SPLASH_SCREEN_DIR}/splash_screen.png --time 0f --quiet
	DEPENDS ${SYNFIG_SPLASH_SCREEN} synfig_bin
)

list(APPEND PIXMAPS ${SPLASH_SCREEN_DIR}/splash_screen.png)
install(
	FILES ${SPLASH_SCREEN_DIR}/splash_screen.png
	DESTINATION share/synfig/images
)

# WIN32 Icon
if(WIN32)
	add_custom_command(
		OUTPUT ${PIXMAPS_DIR}/synfig_icon.ico
		COMMAND synfig_bin ${CMAKE_CURRENT_SOURCE_DIR}/synfig_icon.sif -o ${PIXMAPS_DIR}/synfig_icon.ico --time 0f --quiet
		DEPENDS ${SYNFIG_SPLASH_SCREEN} synfig_bin
	)

	list(APPEND PIXMAPS ${PIXMAPS_DIR}/synfig_icon.ico)
	install(
		FILES ${PIXMAPS_DIR}/synfig_icon.ico
		DESTINATION share/pixmaps/synfigstudio
	)
endif()

add_custom_target(
	build_images
	DEPENDS synfig_bin ${PIXMAPS}
)

=== synfig-studio/plugins/CMakeLists.txt ===
add_subdirectory(add-skeleton-simple)
add_subdirectory(lottie-exporter)
add_subdirectory(view-unhide-all-layers)

add_custom_target(plugins_xml)

if(TARGET plugin_add_skeleton_simple_xml)
    add_dependencies(plugins_xml plugin_add_skeleton_simple_xml)
endif()

if(TARGET plugin_lottie_exporter_xml)
    add_dependencies(plugins_xml plugin_lottie_exporter_xml)
endif()

if(TARGET plugin_view_unhide_all_layers_xml)
    add_dependencies(plugins_xml plugin_view_unhide_all_layers_xml)
endif()

=== synfig-studio/po/CMakeLists.txt ===
include(SynfigGettext)
file(STRINGS LINGUAS PO_LANGUAGES)

SYNFIG_PROCESS_PO_FILES(
    ALL
    TARGET_NAME build_pofiles_synfigstudio
    MO_NAME synfigstudio
    LANGUAGES ${PO_LANGUAGES}
    INSTALL_DESTINATION share/locale
)

=== synfig-studio/sounds/CMakeLists.txt ===
set(INSTALL_DESTINATION "share/synfig/sounds")
set(SOUND_FILES
    renderdone.wav
    readme.txt
)

file(COPY ${SOUND_FILES}
    DESTINATION ${SYNFIG_BUILD_ROOT}/${INSTALL_DESTINATION}
)

install(FILES ${SOUND_FILES}
    DESTINATION ${INSTALL_DESTINATION}
)

=== synfig-studio/src/CMakeLists.txt ===
##
## Find packages
##

## TODO: check version
if ("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
    find_package(synfig CONFIG REQUIRED)
endif()

find_package(Gettext)

if (Gettext_FOUND)
    set(ENABLE_NLS ON)
    set(GETTEXT_PACKAGE ${PROJECT_NAME})
endif()

if(VCPKG_TOOLCHAIN)
	set(GTKMM_LIBRARIES
		${ATK_LIBRARY} ${ATKMM_LIBRARY}
		${CAIROMM_LIBRARY}
		${GDK_LIBRARY}
		${GDKMM_LIBRARY}
		${GIOMM_LIBRARY}
		${GLIB_LIBRARIES}
		${GLIBMM_LIBRARY}
		${GTK_LIBRARY}
		${GTKMM_LIBRARY}
		${PANGOMM_LIBRARY}
	)
else()
	## TODO: check if we really need to find deps common with synfig core
	include(FindPkgConfig)
	if(PKG_CONFIG_FOUND)
		pkg_check_modules(SIGCPP REQUIRED sigc++-2.0)
		pkg_check_modules(GTKMM REQUIRED gtkmm-3.0)
		pkg_check_modules(LIBXML REQUIRED libxml++-2.6)
		pkg_check_modules(PANGO REQUIRED pango) # used in TimeTrackView, OneMoment, etc.
		pkg_check_modules(CAIRO REQUIRED cairo)
		pkg_check_modules(PANGOCAIRO REQUIRED pangocairo)
		pkg_check_modules(MLT mlt++) # required for widget_soundwave
	endif()

	foreach(pkg_config_lib SIGCPP GTKMM LIBXML MLT FFTW PANGO CAIRO PANGOCAIRO)
		include_directories(${${pkg_config_lib}_INCLUDE_DIRS})
		link_directories(${${pkg_config_lib}_LIBRARY_DIRS})
	endforeach()
endif()

if(FONT_CONFIG_FOUND)
	add_definitions(-DWITH_FONTCONFIG)
endif()

if (NOT MLT_FOUND)
	add_definitions(-DWITHOUT_MLT) # disable MLT if not found
endif()

##
## Config
##

if(FONT_CONFIG_FOUND)
add_definitions(-DWITH_FONTCONFIG)
endif()

add_definitions(-DHAVE_CONFIG_H)
configure_file(config.h.cmake.in config.h)

##
## Header include dirs
##

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

include_directories(
        ${SIGCPP_INCLUDE_DIRS}
        ${GTKMM_INCLUDE_DIRS}
)

##
## Search path for libs (needed to link with libsynfig)
##
link_directories(${CMAKE_PREFIX_PATH}/lib)

##
## Sub-directories
##

add_subdirectory(synfigapp)
add_subdirectory(gui)

=== synfig-core/src/modules/CMakeLists.txt ===
##
## Includes
##

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${SYNFIG_BUILD_ROOT}/lib/synfig/modules)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${SYNFIG_BUILD_ROOT}/lib/synfig/modules)

# for multi-config builds (e.g. msvc)
foreach(CONFIG_TYPE  ${CMAKE_CONFIGURATION_TYPES})
	string(TOUPPER ${CONFIG_TYPE} CONFIG_TYPE)
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG_TYPE} ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY})
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG_TYPE} ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
endforeach(CONFIG_TYPE CMAKE_CONFIGURATION_TYPES)

include_directories(
    SYSTEM
        ${SIGCPP_INCLUDE_DIRS}
        ${CAIRO_INCLUDE_DIRS}
        ${GLIBMM_INCLUDE_DIRS}
        ${GIOMM_INCLUDE_DIRS}
)

##
## Modules
##

## TODO: make configurable
## TODO: write some macros

set(MODS_ENABLED
    lyr_freetype
    lyr_std
    mod_bmp
    mod_dv
    mod_example
    mod_ffmpeg
    mod_filter
    mod_geometry
    mod_gif
    mod_gradient
    mod_imagemagick
    mod_jpeg
#    mod_libavcodec # - build failure
#    mod_magickpp # - made optional
    mod_noise
    mod_openexr
    mod_particle
    mod_png
    mod_ppm
    mod_svg
    mod_yuv420p
#    mptr_mplayer # - "This code has vulnerabilities"
)
if(MSVC)
	set(MODS_ENABLED
			lyr_freetype
			lyr_std
			mod_bmp
			#mod_dv
			mod_example
			mod_ffmpeg
			mod_filter
			mod_geometry
			mod_gif
			mod_gradient
			mod_imagemagick
			mod_jpeg
			#    mod_libavcodec # - build failure
			#    mod_magickpp # - made optional
			mod_noise
			#mod_openexr
			mod_particle
			mod_png
			mod_ppm
			mod_svg
			mod_yuv420p
	)
endif()
if(LIBMNG_FOUND)
  list(APPEND MODS_ENABLED mod_mng)
else()
  message(STATUS "mod_mng: Disabled")
endif()

## Magick++ support
option(WITH_MAGICPP "Enable Magic++ module (output format support)" OFF)
option(WITHOUT_MAGICPP "Disable Magic++ module (output format support)" OFF)

if (${WITH_MAGICPP} AND ${WITHOUT_MAGICPP})
    message(FATAL_ERROR "You cannot request both WITH_MAGICPP and WITHOUT_MAGICPP!")
endif()

if (NOT ${WITHOUT_MAGICPP} AND ImageMagick_Magick++_FOUND)
    list(APPEND MODS_ENABLED mod_magickpp)
elseif (${WITH_MAGICPP} AND NOT ImageMagick_Magick++_FOUND)
    message(SEND_ERROR "Magic++ support is requested, but the package cannot be located.")
endif()
## Magick++ support (end)

## Process selected modules
set(SYNFIG_MODULES_CONTENT "")

message("-- Synfig modules:")
foreach(MOD IN ITEMS ${MODS_ENABLED})
    message("--   ${MOD}")
    set(SYNFIG_MODULES_CONTENT "${SYNFIG_MODULES_CONTENT}\n${MOD}")
    add_subdirectory(${MOD})
    add_dependencies(synfig_bin ${MOD})
endforeach(MOD)

file(WRITE ${SYNFIG_BUILD_ROOT}/etc/synfig_modules.cfg ${SYNFIG_MODULES_CONTENT})

install(
    FILES ${SYNFIG_BUILD_ROOT}/etc/synfig_modules.cfg
    DESTINATION etc
)

=== synfig-core/src/synfig/CMakeLists.txt ===
##
## Build targets
##

## Main target: libsynfig
## TODO: optional static linking?
add_library(synfig SHARED "")

add_definitions(-DVERSION="${STUDIO_VERSION_MAJOR}.${STUDIO_VERSION_MINOR}.${STUDIO_VERSION_PATCH}")

message(STATUS "MLT DIR: ${MLT_INCLUDE_DIRS}")

# By default, the libtool places its headers in the system directory (/usr/local/include), and
# compiler automatically finds ltdl.h header. But on MacOS, CMake overrides the system directory
# using the `-sysroot` flag, and this header cannot be found. (https://gitlab.kitware.com/cmake/cmake/-/issues/19120)
# So, we need to manually find it.

if(APPLE OR VCPKG_TOOLCHAIN)
    find_path(LTDL_INCLUDE_DIRS ltdl.h)
    find_library(LTDL_LIBRARIES ltdl)
    message(STATUS "Libltdl headers:   ${LTDL_INCLUDE_DIRS}")
    message(STATUS "Libltdl libraries: ${LTDL_LIBRARIES}")
else()
    set(LTDL_LIBRARIES ltdl)
endif()

target_include_directories(synfig
#    SYSTEM BEFORE PUBLIC
SYSTEM PUBLIC
        ${LIBXML_INCLUDE_DIRS}
PUBLIC
        ${SIGCPP_INCLUDE_DIRS}
        ${GLIBMM_INCLUDE_DIRS}
        ${GIOMM_INCLUDE_DIRS}
        ${MLT_INCLUDE_DIRS}
        ${FFTW_INCLUDE_DIRS}
        ${LTDL_INCLUDE_DIRS}
)

target_sources(synfig
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/activepoint.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/bone.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/blur.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/canvas.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/context.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/curve_helper.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/curveset.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/distance.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/exception.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/guid.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/importer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/keyframe.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/layer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/loadcanvas.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/main.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/module.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/node.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/palette.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/paramdesc.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/polynomial_root.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/rect.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/renddesc.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/render.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/savecanvas.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/string_helper.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/surface.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/time.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/timepointcollect.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/transform.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/uniqueid.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/valuenode.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/valuenode_registry.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/waypoint.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/matrix.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filesystem.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filesystemnative.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filesystemgroup.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filesystemtemporary.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filecontainer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filecontainerzip.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/zstreambuf.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/valueoperations.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/soundprocessor.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/canvasfilenaming.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/token.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/threadpool.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/curve.cpp"
)

## these were added seprately in autotools build, preserving this for now
## TODO: either merge with main list or create new target
target_sources(synfig
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/target_multi.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_null.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_null_tile.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_scanline.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_tile.cpp"
)
target_sources(synfig
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/listimporter.cpp"
)
target_sources(synfig
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/blinepoint.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/widthpoint.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/dashitem.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/gradient.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/type.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/base_types.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/value.cpp"
)

##
## Sub-dirs
##

## include sub-dirs
include(color/CMakeLists.txt)
include(layers/CMakeLists.txt)
include(rendering/CMakeLists.txt)
include(valuenodes/CMakeLists.txt)

## TODO: check if we need this for release build
include(debug/CMakeLists.txt)

target_link_libraries(synfig
    PUBLIC
        ${SIGCPP_LIBRARIES}
        ${GLIBMM_LIBRARIES}
        ${GIOMM_LIBRARIES}
        ${LIBXML_LIBRARIES}
        ${XMLPP_LIBRARIES}
        ${MLT_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${FFTW_LIBRARIES}
        ${LTDL_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
)

## Install headers
## TODO: find a better way to do that, maybe?
file(GLOB SYNFIG_HEADERS "${CMAKE_CURRENT_LIST_DIR}/*.h")

install(
    FILES ${SYNFIG_HEADERS}
    DESTINATION include/synfig
)

install(
    TARGETS synfig
    EXPORT synfig
    LIBRARY DESTINATION lib
)

export(
    EXPORT synfig
    FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}-config.cmake"
)

install(
    EXPORT synfig
    FILE "${PROJECT_NAME}-config.cmake"
    DESTINATION "lib/cmake/${PROJECT_NAME}"
)

=== debian/changelog ===
synfigstudio (1.5.1-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:18:11 +0000

synfigstudio (1.5.1-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 07:03:36 +0000

synfigstudio (1.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.6.0.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 10 Apr 2022 19:44:58 +1000

=== debian/control ===
Source: synfigstudio
Section: graphics
Priority: optional
Standards-Version: 4.6.0
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper-compat (= 11), autopoint, intltool
 ,pkg-config
 ,etl-dev (>= 1.5.1~)
 ,libfftw3-dev
 ,libglibmm-2.4-dev
 ,libgtkmm-3.0-dev
 ,libltdl-dev
 ,libmlt-dev
 ,libmlt++-dev
 ,libsigc++-2.0-dev
 ,libsynfig-dev (>= 1.5.1~)
 ,synfig (>= 1.5.1~)
 ,fonts-freefont-ttf | ttf-freefont
 ,fonts-dejavu | ttf-dejavu
 ,libmagick++-dev
 ,libavcodec-dev
 ,libavformat-dev
 ,libavutil-dev
 ,libswscale-dev
Vcs-Browser: https://salsa.debian.org/multimedia-team/synfigstudio
Vcs-Git: https://salsa.debian.org/multimedia-team/synfigstudio.git
Homepage: http://www.synfig.org/
Rules-Requires-Root: no

Package: synfigstudio
Architecture: any
Recommends: synfig-examples
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: vector-based 2D animation package (graphical user interface)
 synfig is a vector based 2D animation package. It is designed to be
 capable of producing feature-film quality animation. It eliminates the
 need for tweening, preventing the need to hand-draw each frame.
 .
 This package contains the graphical user interface for synfig.

#Package: libsynfigapp0
#Section: libs
#Architecture: any
#Pre-Depends: ${misc:Pre-Depends}
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Description: synfig GUI library
# synfig is a vector based 2D animation package. It is designed to be
# capable of producing feature-film quality animation.
# .
# This package contains the GUI shared library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with autoreconf --sourcedirectory=synfig-studio

override_dh_autoreconf:
	dh_autoreconf
	cd synfig-studio && intltoolize --copy --force

override_dh_auto_configure:
	dh_auto_configure -- \
			--enable-debug=half \
			--with-userdir=.synfig \
			--libdir=\$${prefix}/lib/synfigstudio

override_dh_auto_build:
	cd images ; \
		ln -sv /usr/share/fonts/truetype/freefont/FreeSans.ttf Arial.ttf ; \
		ln -sv /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans-Bold.ttf "Arial Black.ttf" ; \
		ln -sv /usr/share/fonts/truetype/freefont/FreeSerif.ttf "Times New Roman.ttf" ; \
		ln -sv /usr/share/fonts/truetype/freefont/FreeSans.ttf "Sans Serif.ttf"
	dh_auto_build

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp
	## W:unknown-locale-code zh-Hant
	$(RM) -rv $(CURDIR)/debian/tmp/usr/share/locale/zh-Hant

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_strip:
	dh_strip --dbgsym-migration='synfigstudio-dbg (<< 1.2.2-1~)'

=== debian/watch ===
# https://salsa.debian.org/snippets/95
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repack,compression=xz,repacksuffix=+dfsg,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://github.com/synfig/synfig/releases \
  .*/archive/refs/tags/v?(\d[\d\.]+)@ARCHIVE_EXT@$
